//+------------------------------------------------------------------+
//|                                   Copyright  2012, Ivan Kornilov|
//|                                                   MaByMaMulti.mq4|
//|                                   excelf@gmail.com, skype: excelf|
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, Ivan Kornilov. All rights reserved."
#property link "excelf@gmail.com"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Red
#property indicator_color2 DarkOrange
#property indicator_color3 Gold
#property indicator_color4 Green
#property indicator_color5 DeepSkyBlue
#property indicator_color6 Blue
#property indicator_color7 DarkViolet
#property indicator_color7 Black


extern int ma      = 10;
extern int signal  = 10;
extern int maType  = 0;
extern int maPrice = 0;
extern int lineCount = 7;

double SignalBuffer1[];
double SignalBuffer2[];
double SignalBuffer3[];
double SignalBuffer4[];
double SignalBuffer5[];
double SignalBuffer6[];
double SignalBuffer7[];
double SignalBuffer8[];


#include <constants.mqh>
#include <switch.mqh>
#include <indicators\indiUtils.mqh>
#include <indicators\objects.mqh>



int init(){
   SetIndexStyle(0, DRAW_LINE, EMPTY, 1);
   SetIndexStyle(1, DRAW_LINE, EMPTY, 1);

   IndicatorDigits(Digits + 1);

   SetIndexBuffer(0, SignalBuffer1);
   SetIndexBuffer(1, SignalBuffer2);
   SetIndexBuffer(2, SignalBuffer3);
   SetIndexBuffer(3, SignalBuffer4);
   SetIndexBuffer(4, SignalBuffer5);
   SetIndexBuffer(5, SignalBuffer6);
   SetIndexBuffer(6, SignalBuffer7);
   SetIndexBuffer(7, SignalBuffer8);

   IndicatorShortName("MaByMaMulti(" + ma + "," + signal + ")");
   SetIndexLabel(0, "SignalBuffer1");
   SetIndexLabel(1, "SignalBuffer2");
   SetIndexLabel(2, "MABuffer");
   
   objects.initArrawObjects();
}

int start(){
   int countedBars = IndicatorCounted();
   if(countedBars > 0) {
       countedBars--;
   }
   int limit = Bars - countedBars - 1;

   for(int i = limit; i >= 0; i--) {
      SignalBuffer1[i] = iMA(NULL, 0, ma, 0, maType, maPrice, i); 
   } 
   
   if(lineCount > 1)
      for(i = limit; i >= 0; i--) {
         SignalBuffer2[i] = iMAOnArray(SignalBuffer1, 0, signal, 0, maType, i);
      }  
   if(lineCount > 2)
      for(i = limit; i >= 0; i--) {
         SignalBuffer3[i] = iMAOnArray(SignalBuffer2, 0, signal, 0, maType, i);
      }
   if(lineCount > 3)
      for(i = limit; i >= 0; i--) {
         SignalBuffer4[i] = iMAOnArray(SignalBuffer3, 0, signal, 0, maType, i);
      }
   if(lineCount > 4)
      for(i = limit; i >= 0; i--) {
         SignalBuffer5[i] = iMAOnArray(SignalBuffer4, 0, signal, 0, maType, i);
      }
   if(lineCount > 5)
      for(i = limit; i >= 0; i--) {
         SignalBuffer6[i] = iMAOnArray(SignalBuffer5, 0, signal, 0, maType, i);
      }
   if(lineCount > 6)
      for(i = limit; i >= 0; i--) {
         SignalBuffer7[i] = iMAOnArray(SignalBuffer6, 0, signal, 0, maType, i);
      }
   if(lineCount > 7)
      for(i = limit; i >= 0; i--) {
         SignalBuffer8[i] = iMAOnArray(SignalBuffer7, 0, signal, 0, maType, i);
      }
}

int deinit() {
   objects.deinitArrawObjects();
}

